//    WeIRCd administration tool
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

void* generatedconfig = NULL;

void generateconf_AppendLine(const char* line, int depth) {
	char buf[500];
	int r = 0;
	strcopy(buf,"",499);
	while (r < depth) {
		stradd(buf,"\t",499);
		r++;
	}
	stradd(buf,line,499);
	stradd(buf,"\n",499);
	linkedlist_Append(&generatedconfig,&buf,strlen(buf)+1);
}
int countpathdepth(const char* path) {
	int r = 0;int i = 0;
	if (strlen(path) > 0) {i++;}
	while (r < strlen(path)) {
		if (path[r] == '#') {i++;}
		r++;
	}
	return i;
}
void* fetchline = NULL;
void generateconf_New() {
	linkedlist_Free(&generatedconfig);generatedconfig = NULL;
	generateconf_AppendLine(" /* AUTO-GENERATED CONFIG by WeIRCd administration panel */",0);
	generateconf_AppendLine(" /*   Feel free to change manually, but don't edit      ",0);
	generateconf_AppendLine("      and apply settings in the admin panel at the",0);
	generateconf_AppendLine("       same time or it will be overwritten again ;)      */",0);
	generateconf_AppendLine(" /* Autoconf magic brought to you by WeIRCd, the easy IRCd */",0);
	generateconf_AppendLine("",0);
	value_startcycle();
	char line[500];
	const char* nameptr; const char* valueptr;
	while (value_cyclenameandvalue(&nameptr,&valueptr) == 0) {
		char path[50];char name[50];
		strcopy(path,nameptr,49);
		strcopy(name,nameptr,49);
		if (charposfromright(path,'#') > 0) {
			path[charposfromright(path,'#')] = 0;
			cut(name,charposfromright(name,'#')+1);
		}else{
			strcpy(path,"");
		}
		int i = countpathdepth(path);
		if (strcasecmp(name,"FORMATTING") == 0 || strcasecmp(name,"#FORMATTING") == 0) {
			generateconf_AppendLine(valueptr, i);continue;
		}
		if (strcasecmp(name,"LISTVAL") != 0) {
			if (strcasecmp(name,"version") == 0) {continue;} //OMIT to fix old configs
			snprintf(line,499,"%s = %s;",name, valueptr);
			generateconf_AppendLine(line, i);
		}else{
			generateconf_AppendLine(valueptr, i);
		}
	}
	generateconf_AppendLine(" /* END OF FILE */",0);
	fetchline = generatedconfig;
}
const char* generateconf_FetchLine() { /* fetch the generated config line per line until this returns NULL */
	if (fetchline != NULL) {
		void* ret = linkedlist_GetData(fetchline);
		fetchline = linkedlist_NextItem(fetchline);
		return ret;
	}
	return NULL;
}