//    WeIRCd administration tool
//    Copyright (C) 2009-2010 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

void gui_controlnotebook_Msg(struct controlnotebook* c, const char* msg, int type) {
	gtk_widget_hide(c->messageimage);
	gtk_widget_destroy(c->messageimage);
	if (type == MSGTYPE_INFO) {
		gtk_widget_modify_bg(GTK_WIDGET(c->messagecolourbox), GTK_STATE_NORMAL, NULL);
		gtk_widget_modify_fg(GTK_WIDGET(c->messagecolourbox), GTK_STATE_NORMAL, NULL);
		c->messageimage = gtk_image_new_from_stock(GTK_STOCK_DIALOG_INFO, GTK_ICON_SIZE_DIALOG);
	}
	if (type == MSGTYPE_ERROR) {
		GdkColor color;gdk_color_parse ("#ffeecc", &color);
		gtk_widget_modify_bg(GTK_WIDGET(c->messagecolourbox), GTK_STATE_NORMAL, &color);
		gdk_color_parse ("#000000", &color);
		gtk_widget_modify_fg(GTK_WIDGET(c->messagecolourbox), GTK_STATE_NORMAL, &color);
		c->messageimage = gtk_image_new_from_stock(GTK_STOCK_DIALOG_ERROR, GTK_ICON_SIZE_DIALOG);
	}
	if (type == MSGTYPE_WARNING) {
		GdkColor color;gdk_color_parse ("#ffffcc", &color);
		gtk_widget_modify_bg(GTK_WIDGET(c->messagecolourbox), GTK_STATE_NORMAL, &color);
		gdk_color_parse ("#000000", &color);
		gtk_widget_modify_fg(GTK_WIDGET(c->messagecolourbox), GTK_STATE_NORMAL, &color);
		c->messageimage = gtk_image_new_from_stock(GTK_STOCK_DIALOG_WARNING, GTK_ICON_SIZE_DIALOG);
	}
	gtk_widget_show(c->messageimage);
	gtk_box_pack_start(GTK_BOX(c->messagehoribox), c->messageimage, FALSE, FALSE, 0);
	gtk_label_set_markup(GTK_LABEL(c->messagelbl),msg);
	gtk_widget_show(c->messageframe);
}
void gui_controlbook_RemoveMsg(struct controlnotebook* c) {
	gtk_widget_hide(c->messageframe);
}
void gevent_controlbook_startclick(GtkButton *button, gpointer user_data) {
	mainwindowaction_StartServerWithValueCheck();
}
void gevent_controlbook_restartclick(GtkButton *button, gpointer user_data) {
	mainwindow_dlg_AskRestartServer();
}
void gevent_controlbook_stopclick(GtkButton* button, gpointer user_data) {
	mainwindow_dlg_AskStopServer();
}
void gevent_controlbook_rehashclick(GtkButton* button, gpointer user_data) {
	mainwindowaction_RehashServer();
}
void gui_controlbook_Value(GtkWidget* value, const char* str, int type) {
	if (type == 0) {
		char markup[100];snprintf(markup,99,"<i>%s</i> ",str);markup[99] = 0;
		gtk_label_set_markup(GTK_LABEL(value),markup);
	}
	if (type == 1) {
		gtk_entry_set_text(GTK_ENTRY(value), str);
	}
}
void gui_controlnotebook_PackNameValue(GtkWidget* parentbox, const char* title, const char* value, int type, GtkWidget** val) {
	GtkWidget* hbox = gtk_hbox_new(FALSE,0);gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(parentbox),hbox,FALSE,FALSE,2);
	GtkWidget* lbl = gtk_label_new("");
	char titlestr[100];snprintf(titlestr,99,"  %s",title);titlestr[99];
	gtk_label_set_markup(GTK_LABEL(lbl),titlestr);gtk_widget_show(lbl);
	gtk_box_pack_start(GTK_BOX(hbox),lbl,FALSE,FALSE,2);
	if (type == 0) {
		GtkWidget* lblvalue = gtk_label_new(value);
		gui_controlbook_Value(lblvalue,value,0);
		gtk_widget_show(lblvalue);
		gtk_box_pack_end(GTK_BOX(hbox),lblvalue,FALSE,FALSE,2);
		if (val != NULL) {
			*val = lblvalue;
		}
		return;
	}
	if (type == 1) {
		GtkWidget* txtvalue = gtk_entry_new();
		gui_controlbook_Value(txtvalue,value,1);
		gtk_box_pack_end(GTK_BOX(hbox),txtvalue,FALSE,FALSE,2);
		if (val != NULL) {
			*val = txtvalue;
		}
		return;
	}
}
void gui_controlnotebook_CreateDefault(struct tab* parenttab, struct controlnotebook* c, GtkWidget* parent, const char* p) {
	/* some values we want to remember */
	c->parenttab = parenttab;
	
	/* create our notebook */
	c->notebook = gtk_notebook_new();
	
	/* section 1: general frames, message box */
	gtk_container_set_border_width(GTK_CONTAINER(c->notebook), 10);
	gtk_box_pack_start(GTK_BOX(parent), c->notebook, FALSE, FALSE, 0);
	gtk_widget_show(c->notebook);
	GtkWidget* lbox;
	GtkWidget* lbl;
	lbl = gtk_label_new("Status");gtk_widget_show(lbl);
	lbox = gtk_vbox_new(FALSE,0);gtk_widget_show(lbox);
	gtk_notebook_append_page(GTK_NOTEBOOK(c->notebook),lbox,lbl);
	c->messageframe = gtk_frame_new(NULL);
	c->messagecolourbox = gtk_event_box_new();gtk_widget_show(c->messagecolourbox);
	
	gtk_container_set_border_width(GTK_CONTAINER(c->messageframe), 4);
	gtk_frame_set_shadow_type(GTK_FRAME(c->messageframe),GTK_SHADOW_IN);
	c->messagehoribox = gtk_hbox_new(FALSE,0);gtk_widget_show(c->messagehoribox);
	
	gtk_container_add(GTK_CONTAINER(c->messagecolourbox), c->messagehoribox);
	gtk_container_set_border_width(GTK_CONTAINER(c->messagehoribox), 1);
	
	gtk_container_add(GTK_CONTAINER(c->messageframe), c->messagecolourbox);
	
	c->messagelabelvbox = gtk_vbox_new(FALSE,0);gtk_widget_show(c->messagelabelvbox);
	c->messagebuttonhbox = gtk_hbox_new(FALSE,0);gtk_widget_show(c->messagebuttonhbox);
	
	c->messagelbl = gtk_label_new("Some status message.");gtk_widget_show(c->messagelbl);
	gtk_label_set_line_wrap(GTK_LABEL(c->messagelbl),TRUE);
	gtk_box_pack_start(GTK_BOX(c->messagehoribox), c->messagelabelvbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(c->messagelabelvbox), c->messagelbl, TRUE, TRUE, 0);
	gtk_box_pack_end(GTK_BOX(c->messagelabelvbox), c->messagebuttonhbox, FALSE, FALSE, 0);
	c->messageimage = gtk_image_new_from_stock(GTK_STOCK_DIALOG_INFO, GTK_ICON_SIZE_DIALOG);
	gtk_widget_show(c->messageimage);
	gtk_box_pack_end(GTK_BOX(c->messagehoribox), c->messageimage, FALSE, FALSE, 0);
	
	gtk_box_pack_start(GTK_BOX(lbox), c->messageframe, FALSE, FALSE, 0);
	
	/* Section 2: status frame */
	
	GtkWidget* hbox = gtk_hbox_new(FALSE,3);gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(lbox), hbox, FALSE, FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox), 2);
	
	GtkWidget* hvbox = gtk_vbox_new(FALSE,0);gtk_widget_show(hvbox);
	GtkWidget* statusframe = gtk_frame_new("Status");gtk_widget_show(statusframe);
	
	GtkWidget* statusframevbox = gtk_vbox_new(FALSE,2);gtk_widget_show(statusframevbox);
	gtk_container_add(GTK_CONTAINER(statusframe),statusframevbox);
	
	gui_controlnotebook_PackNameValue(statusframevbox,"Status","Stopped",0,&c->value_status);
	if (p != NULL) {
		gui_controlnotebook_PackNameValue(statusframevbox,"Server version",p,0,NULL);
	}else{
		gui_controlnotebook_PackNameValue(statusframevbox,"Server version","&#60;unknown>",0,NULL);
	}
	/* Section 2: control frame */	  
	GtkWidget* hboxsurrounder = gtk_event_box_new();gtk_widget_show(hboxsurrounder);
	gtk_box_pack_start(GTK_BOX(hbox),hboxsurrounder,FALSE,FALSE,0);
	gtk_container_add(GTK_CONTAINER(hboxsurrounder),statusframe);
	gtk_container_set_border_width(GTK_CONTAINER(statusframe), 4);
	
	gtk_box_pack_end(GTK_BOX(hbox),hvbox,TRUE,TRUE,0);
	GtkWidget* frame = gtk_frame_new("Control");gtk_widget_show(frame);
	gtk_box_pack_end(GTK_BOX(hvbox),frame,TRUE,TRUE,0);
	
	GtkWidget* buttonrows = gtk_vbox_new(FALSE,0);gtk_widget_show(buttonrows);
	gtk_container_add(GTK_CONTAINER(frame),buttonrows);
	
	GtkWidget* framebox = gtk_hbox_new(FALSE,0);gtk_widget_show(framebox);
	gtk_box_pack_start(GTK_BOX(buttonrows),framebox,FALSE,FALSE,0);
	
	gtk_container_set_border_width(GTK_CONTAINER(framebox), 4);
	
	c->tabc_start = gtk_button_new_with_label("Start server");gtk_widget_show(c->tabc_start);
	g_signal_connect(G_OBJECT(c->tabc_start), "clicked", G_CALLBACK(gevent_controlbook_startclick),
				 c);
	gtk_button_set_image(GTK_BUTTON(c->tabc_start), gtk_image_new_from_stock(GTK_STOCK_MEDIA_PLAY,GTK_ICON_SIZE_BUTTON));
	gtk_box_pack_start(GTK_BOX(framebox),c->tabc_start,TRUE,TRUE,2);
	
	c->tabc_restart = gtk_button_new_with_label("Restart server");gtk_widget_show(c->tabc_restart);
	gtk_button_set_image(GTK_BUTTON(c->tabc_restart), gtk_image_new_from_stock(GTK_STOCK_REFRESH,GTK_ICON_SIZE_BUTTON));
	gtk_box_pack_start(GTK_BOX(framebox),c->tabc_restart,TRUE,TRUE,2);
	g_signal_connect(G_OBJECT(c->tabc_restart), "clicked", G_CALLBACK(gevent_controlbook_restartclick),c);
	
	c->tabc_stop = gtk_button_new_with_label("Stop server");gtk_widget_show(c->tabc_stop);
	g_signal_connect(G_OBJECT(c->tabc_stop), "clicked", G_CALLBACK(gevent_controlbook_stopclick),
				 c);
	gtk_button_set_image(GTK_BUTTON(c->tabc_stop), gtk_image_new_from_stock(GTK_STOCK_STOP,GTK_ICON_SIZE_BUTTON));
	gtk_box_pack_start(GTK_BOX(framebox),c->tabc_stop,TRUE,TRUE,2);
	c->tabc_rehash = gtk_button_new_with_label("Reload configuration");gtk_widget_show(c->tabc_rehash);
	gtk_button_set_image(GTK_BUTTON(c->tabc_rehash), gtk_image_new_from_stock(GTK_STOCK_REDO,GTK_ICON_SIZE_BUTTON));
	g_signal_connect(G_OBJECT(c->tabc_rehash), "clicked", G_CALLBACK(gevent_controlbook_rehashclick),
				 c);

	GtkWidget* frameboxforreload = gtk_hbox_new(FALSE,0);gtk_widget_show(frameboxforreload);
	gtk_box_pack_start(GTK_BOX(buttonrows),frameboxforreload,FALSE,FALSE,0);
	gtk_container_set_border_width(GTK_CONTAINER(frameboxforreload), 4);
	
	gtk_box_pack_start(GTK_BOX(frameboxforreload),c->tabc_rehash,TRUE,TRUE,2);
	
	frame = gtk_frame_new("User stats");gtk_widget_show(frame);
	gtk_box_pack_start(GTK_BOX(hvbox),frame,FALSE,FALSE,4);
	/* userstats contents start */
	GtkWidget* usershbox = gtk_hbox_new(FALSE,0);gtk_widget_show(usershbox);
	gtk_container_set_border_width(GTK_CONTAINER(usershbox), 4);
	gtk_container_add(GTK_CONTAINER(frame),usershbox);
	GtkWidget* userslocallabel = gtk_label_new("Local users:");gtk_widget_show(userslocallabel);
	gtk_box_pack_start(GTK_BOX(usershbox),userslocallabel,TRUE,FALSE,4);
	c->users_local = gtk_entry_new();gtk_widget_show(c->users_local);
	gtk_widget_set_size_request(c->users_local,40,-1);
	gtk_entry_set_text(GTK_ENTRY(c->users_local),"0");
	gtk_editable_set_editable(GTK_EDITABLE(c->users_local),FALSE);
	gtk_widget_set_sensitive(c->users_local,FALSE);
	gtk_box_pack_start(GTK_BOX(usershbox),c->users_local,TRUE,FALSE,4);
	userslocallabel = gtk_label_new("Global users:");gtk_widget_show(userslocallabel);
	gtk_box_pack_start(GTK_BOX(usershbox),userslocallabel,TRUE,FALSE,4);
	c->users_global = gtk_entry_new();gtk_widget_show(c->users_global);
	gtk_entry_set_text(GTK_ENTRY(c->users_global),"0");
	gtk_editable_set_editable(GTK_EDITABLE(c->users_global),FALSE);
	gtk_widget_set_sensitive(c->users_global,FALSE);
	gtk_widget_set_size_request(c->users_global,40,-1);
	gtk_box_pack_start(GTK_BOX(usershbox),c->users_global,TRUE,FALSE,4);
	userslocallabel = gtk_label_new("Operators:");gtk_widget_show(userslocallabel);
	gtk_box_pack_start(GTK_BOX(usershbox),userslocallabel,TRUE,FALSE,4);
	c->opers = gtk_entry_new();gtk_widget_show(c->opers);
	gtk_entry_set_text(GTK_ENTRY(c->opers),"0");
	gtk_editable_set_editable(GTK_EDITABLE(c->opers),FALSE);
	gtk_widget_set_sensitive(c->opers,FALSE);
	gtk_widget_set_size_request(c->opers,40,-1);
	gtk_box_pack_start(GTK_BOX(usershbox),c->opers,TRUE,FALSE,4);
	
	/* userstats contents eend */
	
	/* settings tab start */
	
	lbl = gtk_label_new("Settings");gtk_widget_show(lbl);
	lbox = gtk_vbox_new(FALSE,0);gtk_widget_show(lbox);
	constructsettings(c, lbox, &c->s);
	gtk_notebook_append_page(GTK_NOTEBOOK(c->notebook),lbox,lbl);
	
	/* settings tab end */
}