//    WeIRCd administration tool
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

/* simple true/false value will become a check box: */
#define VARTYPE_CHECKBOX 1

/* complex integer or strings become entry fields: */
#define VARTYPE_ENTRY 2

/* simple integer get a up/down counter: */
#define VARTYPE_INTCOUNT 3

/* for a limited amount of options to choose from, we take a combo box: */
#define VARTYPE_COMBOBOX 4

struct settingsvalue {
	int type; /* free string? true/false? integer? also hints the type of the widget */
	char* name;
	GtkWidget* settingswidget; /* the widget to read the value from */
};



struct settingstab {
	GtkWidget* parentframe; /* the frame that contains the whole settings tab */
	struct controlnotebook* parentnotebook;
	
	GtkListStore* categoriesstore; /* storing the category list model */
	GtkWidget* categoriesview; /* showing the category list */
	GtkWidget* contentscroller; /* container for the actual category's content */
	GtkWidget* applybutton;
	GtkWidget* discardbutton;
	
	int dontwatchchanges; /* if set to 1, then do not enable apply/discard on changes (we are just filling in config data) */
	
	void* settingssubtabslist; /* sub tabs which contain the different categories */
	GtkWidget* shownsubtab; /* reference to the current category's sub tab (or NULL) */
};
struct settingssubtab {
	struct settingstab* parenttab;
	GtkWidget* parentbox; //a vbox
	char* name; //a category name so we can easily find it later
	void* valueslist; //we don't need all the widgets, but the values and their specific entry widgets
};
void constructsettings(struct controlnotebook* parentnotebook, GtkWidget* frame, struct settingstab* s);
int loadicons();
extern GdkPixbuf* applogo;
int loadwinlogo();