//    WeIRCd IRC server software - sub file
//    Copyright (C) 2010 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

#define MAXEVENTPARAMS 30  // that's most likely sufficient

union eventparam {
	int intvalue;
	float floatvalue;
	char* stringvalue;
};
union eventparam eparams[MAXEVENTPARAMS];

void linkingeventparams_Clear() {
	int r = 0;
	while (r < MAXEVENTPARAMS) {
		memset(&eparams[r], 0, sizeof(eparams[r]));
		r++;
	}
}
void linkingeventparams_SetInt(int param, int value) {
	if (param > MAXEVENTPARAMS || param < 1) {return;}
	eparams[param-1].intvalue = value;
}
void linkingeventparams_SetStr(int param, const char* value) {
	if (param > MAXEVENTPARAMS || param < 1) {return;}
	eparams[param-1].stringvalue = value;
}
void linkingeventparams_SetFloat(int param, float value) {
	if (param > MAXEVENTPARAMS || param < 1) {return;}
	eparams[param-1].floatvalue = value;
}
int linkingeventparams_GetInt(int param) {
	if (param > MAXEVENTPARAMS || param < 1) {return 0;}
	return eparams[param-1].intvalue;
}
const char* linkingeventparams_GetStr(int param) {
	if (param > MAXEVENTPARAMS || param < 1) {return 0;}
	return eparams[param-1].stringvalue;
}
float linkingeventparams_GetFloat(int param) {
	if (param > MAXEVENTPARAMS || param < 1) {return 0;}
	return eparams[param-1].floatvalue;
}

// wrappers for the module linking api
int module_linking_EventParamInt(int param) {
	return linkingeventparams_GetInt(param);
}
const char* module_linking_EventParamStr(int param) {
	return linkingeventparams_GetStr(param);
}
float module_linking_EventParamInt(int param) {
	return linkingeventparams_GetFloat(param);
}