//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

char extinfobuf[400];
void extadd(const char* n) {
	if (strcasecmp(extinfobuf,"") != 0) {strcat(extinfobuf,", ");}
	strcat(extinfobuf,n);
}
const char* extensioninfo() {
	strcpy(extinfobuf,"");
#ifdef IPV6
	extadd("IPv6 sockets");
#endif
#ifdef WIN
	extadd("windows mod");
#endif
	if (strcasecmp(extinfobuf,"") == 0) {strcpy(extinfobuf,"no extensions");}
	return extinfobuf;
}
int startup_WeircdInit(const char* version) {
	strncpy(version_copy,version,49);
	version_copy[49] = 0;
	printf("----------------------------------------------\n");
	printf(" ___    __    ___                             \n");
	printf(" \\  \\  /  \\  /  /.---. .-. .---.   .-. .--.   \n");
	printf("  |  \\/    \\/  | | .-' | | | .. \\ / /  | . \\  \n");
	printf("   \\    ..    /  | '-. | | | '' / | |  | || | \n");
	printf("    |   ||   |   | .-' | | | \\ \\  | |  | || | \n");
	printf("    \\  /  \\  /   | '-. | | | |\\ \\ \\ \\  | ' /  \n");
	printf("     \\/    \\/    '---' '-' '-' '-' '-' '--'   \n");
	printf("\n");
	printf("    Version %s (%s)\n",version_copy,extensioninfo());
	printf("----------------------------------------------\n\n");
	//weircdIpsInit();
	return 0;
}
int startup_ForkIntoBackground() {
#ifndef WIN
	int r;
	r = fork();
	if (r < 0) {return -2;}
	if (r == 0) {
		return 0;
	}else{
      return -1;
	}
#endif
#ifdef WIN
	return 0;//no fork, just continue
#endif
}
